<%@ Page Language="VB" Debug="True" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Data" %>

<!-- Author XML data. -->
<XML ID="xmlAuthors" RUNAT="server">
  <Authors>
    <Author>
      <FirstName>Merlin &amp; Cobe</FirstName>
      <LastName>(Cats)</LastName>
      <EmailAddress>MerlinAndCobe@vb-helper.com</EmailAddress>
      <HomePageName>Humane Society of Boulder Valley</HomePageName>
      <HomePageURL>http://www.boulderhumane.org/html/animals/pages/cats.htm</HomePageURL>
      <Image>./cats.jpg</Image>
    </Author>
    <Author>
      <FirstName>Snortimer</FirstName>
      <LastName>(Dog)</LastName>
      <EmailAddress>Dog@vb-helper.com</EmailAddress>
      <HomePageName>Humane Society of Boulder Valley</HomePageName>
      <HomePageURL>http://www.boulderhumane.org/html/animals/pages/dogs.htm</HomePageURL>
      <Image>./dog.jpg</Image>
    </Author>
    <Author>
      <FirstName>Rod</FirstName>
      <LastName>Stephens</LastName>
      <EmailAddress>RodStephens@vb-helper.com</EmailAddress>
      <HomePageName>VB Helper</HomePageName>
      <HomePageURL>http://www.vb-helper.com</HomePageURL>
      <Image>./rod.jpg</Image>
    </Author>
    <Author>
      <FirstName>Brian</FirstName>
      <LastName>Hochgurtel</LastName>
      <EmailAddress>brian@advocatemedia.com</EmailAddress>
      <HomePageName>Advocate Media</HomePageName>
      <HomePageURL>http://www.advocatemedia.com</HomePageURL>
      <Image>./brian.jpg</Image>
    </Author>
  </Authors>
</XML>

<!-- Bind the data to the DataGrid control. -->
<SCRIPT Language="VB" RUNAT="Server">

  Sub Page_Load(sender As Object, e As EventArgs)
    ' See if the this the first time we have loaded.
    If Not IsPostBack Then
      ' Load the data.
      grdAuthors.DataSource = MakeDataSource()
      grdAuthors.DataBind()
    End If
  End Sub

  ' Return a data source containing the data.
  Function MakeDataSource(Optional ByVal sort_column As String = "Name") As ICollection
    ' Load the XML data into a DataSet.
    Dim string_reader As New StringReader(xmlAuthors.InnerHTML)
    Dim data_set As New DataSet
    data_set.ReadXml(string_reader)

    ' Add a new Name column combining FirstName and LastName.
    data_set.Tables(0).Columns.Add("Name", _
      System.Type.GetType("System.String"), _
      "FirstName + ' ' + LastName")

    ' Make a DataView that sorts on the right column.
    Dim data_view As New DataView(data_set.Tables(0))
    data_view.Sort = sort_column

    ' Return the DataView.
    Return data_view
  End Function

  ' Move to the page the visitor clicked.
  Sub Grid_Sort(sender As Object, e As DataGridSortCommandEventArgs)
    ' Rebind the data.
    grdAuthors.DataSource = MakeDataSource(e.SortExpression.ToString())
    grdAuthors.DataBind()
  End Sub
</SCRIPT>

<!-- HTML Code. -->
<HTML>
<HEAD>
  <TITLE>SortedDataGrid</TITLE>
</HEAD>
<BODY>

  <H1><CENTER>SortedDataGrid</CENTER></H1>

  <FORM RUNAT="server">
    <!-- Create the data grid. -->
    <ASP:DATAGRID ID="grdAuthors" RUNAT="Server"
      CELLPADDING="5"
      BORDERCOLOR="black"
      BACKCOLOR="lightgray"
      AUTOGENERATECOLUMNS="False"
      ALLOWSORTING="True"
      OnSortCommand="Grid_Sort"
    >
      <HEADERSTYLE BACKCOLOR="darkgray">
        <FONT BOLD="true" />
      </HEADERSTYLE>
      <ALTERNATINGITEMSTYLE
        BACKCOLOR="silver"
      />
      <COLUMNS>
        <ASP:BOUNDCOLUMN HEADERTEXT="Name" DATAFIELD="Name"
          SORTEXPRESSION="Name"
        />
        <ASP:BOUNDCOLUMN HEADERTEXT="Email" DATAFIELD="EmailAddress"
          DATAFORMATSTRING="<A HREF='mailto:{0}'>{0}</A>"
          SORTEXPRESSION="EmailAddress"
        />
        <ASP:HYPERLINKCOLUMN HEADERTEXT="Home Page"
          DATANAVIGATEURLFIELD="HomePageURL"
          DATATEXTFIELD="HomePageName"
          SORTEXPRESSION="HomePageName"
        />
        <ASP:BOUNDCOLUMN HEADERTEXT="Image" DATAFIELD="Image"
          DATAFORMATSTRING="<IMG SRC='{0}' HEIGHT='70'></IMG>"
        />
      </COLUMNS>
    </ASP:DATAGRID>
  </FORM>
</BODY>
</HTML>
